using System;using System.Collections.Generic;using System.Threading.Tasks;using EventQMobileApp.Services.Repository;

namespace EventQMobileApp{    public class DataService : BaseService, IDataService    {        IUserRepository _userRepository;        public DataService(IUserRepository userRepository) : base(AppConfig.API_URL)        {            _userRepository = userRepository;        }        public async Task<bool> SignInWithEmailPassword(string emailAddress, string password)        {            var body = new List<KeyValuePair<string, string>>            {              new KeyValuePair<string,string>("grant_type","password"),              new KeyValuePair<string,string>("username",emailAddress),              new KeyValuePair<string,string>("password",password)            };            try            {                var response = await _restClient.PostHttpResponse<TokenModel>(AppConfig.VALIDATION, string.Empty, body);                if (response != null)                {                    Identity.IdToken = response.AccessToken;

                    #region DataCache

                    var user = _userRepository.Single(x => x.UserName == emailAddress);
                    if (user != null)
                    {
                        user.Token = response.AccessToken;
                        _userRepository.Update(user);
                    }                    else
                    {
                        _userRepository.Add(new User
                        {
                            UserName = emailAddress,
                            Password = password,
                            Token = response.AccessToken
                        });
                    }                    _userRepository.Save();

                    #endregion

                    return true;                }                return false;            }            catch (Exception ex)            {                await AppInsights.ReportAsync(ex);                return false;            }        }        public async Task<StandardResponse<User>> GetUser(User user)        {            StandardResponse<User> response = new StandardResponse<User>();            try            {                string itemResource = string.Format(AppConfig.VALIDATION);                var jsonBody = CamelCaseJsonSerializer.SerializeObject(user);                response = await _restClient.PostHttpResponse<StandardResponse<User>>(itemResource, jsonBody);                if (response != null && response.Result != null)                    return response;            }            catch (Exception ex)            {                await AppInsights.ReportAsync(ex);            }            return response;        }        public async Task<List<Event>> GetEvents(int? page, int? count = 30)
        {
            try
            {
                var itemResource = string.Format(AppConfig.FETCH_EVENTS, page, count);
                var response = await _restClient.GetHttpResponse<List<Event>>(itemResource, null);
                return response;
            }
            catch (Exception ex)
            {
                await AppInsights.ReportAsync(ex);
            }
            return null;
        }

        public IEnumerable<Attendee> GetAttendees()        {            try            {
                //TODO : API response has to replace the hard coded data

                IEnumerable<Attendee> attendeeList;
                //if (_iAttendeeRepository.Get() != null)
                //{
                attendeeList = new List<Attendee>                    {                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now.AddMinutes(40),                            SurName = "Partha",                            FirstName = "Sarathi",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "usarathi@yahoo.com",                            Organisation = "Infosys",                            AttendeeLabel = "Green Team",                            Table = "T2",                            SeatNumber = "2",                            IsVip = true,                            IsEntranceDone = true                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now,                            SurName = "Balaji",                            FirstName = "Manivannan",                            AttendeeType = AttendeesType.Speakers.GetDescription(),                            Organisation = "Williams",                            Email = "balaji@qmeeto.com",                            AttendeeLabel = "Blue King",                            Table = "T2",                            SeatNumber = "7",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddMinutes(25),                            SurName = "Dinesh",                            FirstName = "Baskar",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "baskaran@gmail.com",                            Organisation = "CTS",                            AttendeeLabel = "Blue King",                            Table = "T1",                            IsEntranceDone = true,                            SeatNumber = "6",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddHours(1),                            SurName = "Vivin",                            FirstName = "Savin",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "savin@gmail.com",                            Organisation = "WorldMart",                            AttendeeLabel = "Pink Queen",                            Table = "T2",                            IsEntranceDone = true,                            IsVip = true,                            SeatNumber = "4",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Ms.",                            CheckInTime = DateTime.Now.AddMinutes(40),                            SurName = "Narmathai",                            FirstName = "R",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "usarathi@yahoo.com",                            Organisation = "Infosys",                            AttendeeLabel = "Green Team",                            Table = "T2",                            SeatNumber = "2",                            IsVip = true,                            IsEntranceDone = true                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Mr.",                            CheckInTime = DateTime.Now,                            SurName = "Rajendran",                            FirstName = "vekataswamy",                            AttendeeType = AttendeesType.Speakers.GetDescription(),                            Organisation = "Williams",                            Email = "balaji@qmeeto.com",                            AttendeeLabel = "Blue King",                            Table = "T2",                            SeatNumber = "7",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddMinutes(25),                            SurName = "John",                            FirstName = "Lee",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "John@gmail.com",                            Organisation = "DSRC",                            AttendeeLabel = "Blue King",                            Table = "T2",                            IsEntranceDone = true,                            SeatNumber = "5",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddHours(1),                            SurName = "Mark",                            FirstName = "Antov",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "Markantov@gmail.com",                            Organisation = "WorldMart",                            AttendeeLabel = "Pink Queen",                            Table = "T2",                            IsEntranceDone = true,                            IsVip = true,                            SeatNumber = "4"                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now.AddMinutes(40),                            SurName = "Peter",                            FirstName = "worth",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "Peter@yahoo.com",                            Organisation = "Infosys",                            AttendeeLabel = "Green Team",                            Table = "T2",                            SeatNumber = "2",                            IsVip = true,                            IsEntranceDone = true                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now,                            SurName = "Jems",                            FirstName = "Kelvin",                            AttendeeType = AttendeesType.Speakers.GetDescription(),                            Organisation = "Williams",                            Email = "kelvin@qmeeto.com",                            AttendeeLabel = "Blue King",                            Table = "T2",                            SeatNumber = "7",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddMinutes(25),                            SurName = "Mauris",                            FirstName = "Morphy",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "Mauris_morphy@qmeeto.com",                            Organisation = "CTS",                            AttendeeLabel = "Blue King",                            Table = "T1",                            IsEntranceDone = true,                            SeatNumber = "6",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddHours(1),                            SurName = "Joe",                            FirstName = "Surya",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "savin@gmail.com",                            Organisation = "WorldMart",                            AttendeeLabel = "Pink Queen",                            Table = "T3",                            IsEntranceDone = false,                            IsVip = true,                            SeatNumber = "2",                        },new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now.AddMinutes(40),                            SurName = "Tom",                            FirstName = "Jerry",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "JerryTom@yahoo.com",                            Organisation = "Infosys",                            AttendeeLabel = "Green Team",                            Table = "T2",                            SeatNumber = "2",                            IsVip = true,                            IsEntranceDone = true                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Dr.",                            CheckInTime = DateTime.Now,                            SurName = "Kannan",                            FirstName = "Manivannan",                            AttendeeType = AttendeesType.Speakers.GetDescription(),                            Organisation = "Williams",                            Email = "balaji@qmeeto.com",                            AttendeeLabel = "Blue King",                            Table = "T2",                            SeatNumber = "7",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddMinutes(25),                            SurName = "Karthik",                            FirstName = "Sivaguru",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "sivaguru@gmail.com",                            Organisation = "CTS",                            AttendeeLabel = "Blue King",                            Table = "T1",                            IsEntranceDone = true,                            SeatNumber = "6",                        },                        new Attendee()                        {                            AttendeeId = Guid.NewGuid(),                            Title = "Engg.",                            CheckInTime = DateTime.Now.AddHours(1),                            SurName = "Alan",                            FirstName = "Morphy",                            AttendeeType = AttendeesType.Delegates.GetDescription(),                            Email = "savin@gmail.com",                            Organisation = "WorldMart",                            AttendeeLabel = "Pink Queen",                            Table = "T2",                            IsEntranceDone = true,                            IsVip = true,                            SeatNumber = "4",                        }                    };
                //    _iAttendeeRepository.AddRange(attendeeList.ToList());
                //    _iAttendeeRepository.Save();
                //}
                //attendeeList = _iAttendeeRepository.Get();

                return attendeeList;            }            catch (Exception ex)            {                return null;            }        }    }}